<template>
  <div class="drawer_info">
    <div class="drawer_title">{{ dataForm.id ? "修改" : "新增" }}</div>
    <el-form
      ref="dataForm"
      :model="dataForm"
      :rules="dataRule"
      @keyup.enter.native="dataFormSubmitHandle()"
      class="drawer_list"
    >
      <el-form-item prop="beanName" :label="$t('schedule.beanName')">
        <el-input
          v-model="dataForm.beanName"
          :placeholder="$t('schedule.beanNameTips')"
        />
      </el-form-item>
      <el-form-item prop="params" :label="$t('schedule.params')">
        <el-input
          v-model="dataForm.params"
          :placeholder="$t('schedule.params')"
        />
      </el-form-item>
      <el-form-item
        prop="cronExpression"
        :label="$t('schedule.cronExpression')"
      >
        <el-popover v-model="cronPopover">
          <cron i18n="cn" @change="changeCron" @close="cronPopover = false" />
          <el-input
            slot="reference"
            v-model="dataForm.cronExpression"
            :placeholder="$t('schedule.cronExpressionTips')"
            @click="cronPopover = true"
          />
        </el-popover>
      </el-form-item>
      <el-form-item prop="remark" :label="$t('schedule.remark')">
        <el-input
          v-model="dataForm.remark"
          :placeholder="$t('schedule.remark')"
        />
      </el-form-item>
    </el-form>
    <div class="save_btn">
      <el-button type="primary" @click="dataFormSubmitHandle()">
        {{ $t("confirm") }}
      </el-button>
      <el-button plain @click="resetForm('dataForm')">重置</el-button>
    </div>
  </div>
</template>

<script>
import debounce from "lodash/debounce";
import { cron } from "vue-cron";
export default {
  components: {
    cron,
  },
  data() {
    return {
      dataForm: {
        id: "",
        beanName: "",
        params: "",
        cronExpression: "",
        remark: "",
        status: 0,
      },
      cronPopover: false,
    };
  },
  computed: {
    dataRule() {
      return {
        beanName: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        cronExpression: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
      };
    },
  },
  methods: {
    init() {
      this.$nextTick(() => {
        this.$refs["dataForm"].resetFields();
        if (this.dataForm.id) {
          this.getInfo();
        }
      });
    },
    resetForm(formName) {
      this.$refs[formName].resetFields();
      this.dataForm.id = this.id;
    },
    changeCron(val) {
      this.dataForm.cronExpression = val;
    },
    // 获取信息
    getInfo() {
      this.$http
        .get(`/sys/schedule/${this.dataForm.id}`)
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.dataForm = res.data;
        })
        .catch(() => {});
    },
    // 表单提交
    dataFormSubmitHandle: debounce(
      function () {
        this.$refs["dataForm"].validate((valid) => {
          if (!valid) {
            return false;
          }
          this.$http[!this.dataForm.id ? "post" : "put"](
            "/sys/schedule",
            this.dataForm
          )
            .then(({ data: res }) => {
              if (res.code !== 0) {
                return this.$message.error(res.msg);
              }
              this.$message({
                message: this.$t("prompt.success"),
                type: "success",
                duration: 500,
                onClose: () => {
                  this.$emit("refreshDataList");
                },
              });
            })
            .catch(() => {});
        });
      },
      1000,
      { leading: true, trailing: false }
    ),
  },
};
</script>
<style lang="scss">
.customWidth.alert {
  width: 50%;
  .el-dialog__title {
    border-left: 4px solid #ddd;
    padding-left: 8px;
    border-color: #5776e6;
  }
}
</style>
